/*
  ProgEx40b  -- Form3: Volume Of Your Box.  Retrieving Data From Edit Controls and Combo
                Box, Doing  Calculations, And Returning Results To Volume Edit Control.

  At this point we have the button click procedures working, so all we need to do now is
  figure out how to get data out of the edit controls so we can do some calculations.  As
  it turns out there is a SendMessage() call that will extract info out of an edit
  control but GetWindowText() is usually easier...

                                     --Microsoft--

  int GetWindowText
  (
   HWND hWnd,        // handle to window or control with text
   LPTSTR lpString,  // address of buffer for text
   int nMaxCount     // maximum number of characters to copy
  );

  Parameters

  hWnd       Handle to the window or control containing the text.
  lpString   Pointer to the buffer that will receive the text.
  nMaxCount  Specifies the maximum number of characters to copy to the buffer, including
             the NULL character. If the text exceeds this limit, it is truncated.

                                   --End Microsoft--

  From reading the above documentation it looks like we need the window handles of all the
  edit controls to use the function.  All those I threw away back in fnWndProc_OnCreate()
  where they were all returned to me in the CreateWindow() calls that created them.
  'Waste not, want not' is the old saying, and I guess its true!

  Well, I'm as big a belierer in frugality and the 'waste not, want not' philosophy as
  anyone (you ought to see my celler and outbuildings), but as you know we can retrieve
  these window handles anytime we want as long as we have their control ids and parent
  window handle and we indeed have those.  Without further ado here is the next version of
  our program and all the changes from the last are in...

  void btnCalculate_OnClick(lpWndEventArgs Wea)

  Oh!  That's not completely true!  I had to add the stdio.h header for the sprintf
  function which I needed to convert a double representing the volume back into a
  character string.  I didn't include my String Class here because I thought it was a
  little overkill for the fairly lightweight string minipulations we needed here.

  And still another thing I almost forgot!  I added a struct named ProgramData to
  ProgEx40b.h.  It just amalgamates the characteristics of a box into a struct...

  struct ProgramData
  {
   double  dblLength;
   double  dblWidth;
   double  dblHeight;
   double  dblVolume;
   char    szBoxType[16];
  };

  Its used in btnCalculate_OnClick().

  Our next job will be to look at what we need to do to get a display screen up and
  running.  By the way, I just compiled this with CodeBlocks, and the executable is up
  to a whopping 9K!  Talk about code bloat!
*/

//Main.cpp
#include <windows.h>
#include <stdio.h>
#include "ProgEx40b.h"
EVENTHANDLER  EventHandler[3];


long fnWndProc_OnCreate(lpWndEventArgs Wea)
{
 char* szBuffer[]={"Ordinary Box","Box Of Junk","Beer Crate","Wine Box","Candy Box"};
 DWORD dwStyle=WS_CHILD|WS_VISIBLE|WS_TABSTOP;
 HWND hCtl;

 Wea->hIns=((LPCREATESTRUCT)Wea->lParam)->hInstance;
 hCtl=CreateWindow("static","Choose Kind of Box",WS_CHILD|WS_VISIBLE,10,10,140,25,Wea->hWnd,(HMENU)-1,Wea->hIns,0);
 hCtl=CreateWindow("combobox","",dwStyle|CBS_DROPDOWNLIST|WS_VSCROLL,150,10,140,100,Wea->hWnd,(HMENU)IDC_COMBO_TYPE,Wea->hIns,0);
 for(unsigned int i=0; i<5; i++)
     SendMessage(hCtl,CB_INSERTSTRING,(WPARAM)-1,(LPARAM)szBuffer[i]);
 SendMessage(hCtl,CB_SETCURSEL,(WPARAM)0,0);  //|WS_TABSTOP
 hCtl=CreateWindow("static","Length of Box",WS_CHILD|WS_VISIBLE,10,53,125,25,Wea->hWnd,(HMENU)-1,Wea->hIns,0);
 hCtl=CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",dwStyle,150,50,70,25,Wea->hWnd,(HMENU)IDC_EDIT_LENGTH,Wea->hIns,0);
 hCtl=CreateWindow("static","Width of Box",WS_CHILD|WS_VISIBLE,10,93,125,25,Wea->hWnd,(HMENU)-1,Wea->hIns,0);
 hCtl=CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",dwStyle,150,90,70,25,Wea->hWnd,(HMENU)IDC_EDIT_WIDTH,Wea->hIns,0);
 hCtl=CreateWindow("static","Height of Box",WS_CHILD|WS_VISIBLE,10,133,125,25,Wea->hWnd,(HMENU)-1,Wea->hIns,0);
 hCtl=CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",dwStyle,150,130,70,25,Wea->hWnd,(HMENU)IDC_EDIT_HEIGHT,Wea->hIns,0);
 hCtl=CreateWindow("static","Volume",WS_CHILD|WS_VISIBLE,10,183,50,25,Wea->hWnd,(HMENU)-1,Wea->hIns,0);
 hCtl=CreateWindowEx(WS_EX_CLIENTEDGE,"edit","",dwStyle,60,180,335,25,Wea->hWnd,(HMENU)IDC_EDIT_VOLUME,Wea->hIns,0);
 hCtl=CreateWindow("button","Calculate",dwStyle,245,65,120,30,Wea->hWnd,(HMENU)IDC_BUTTON_CALCULATE,Wea->hIns,0);
 hCtl=CreateWindow("button","Display",dwStyle,245,110,120,30,Wea->hWnd,(HMENU)IDC_BUTTON_DISPLAY,Wea->hIns,0);
 SetWindowText(Wea->hWnd,"Volume Of Your Box");
 SetFocus(GetDlgItem(Wea->hWnd,IDC_COMBO_TYPE));

 return 0;
}


void btnCalculate_OnClick(lpWndEventArgs Wea)
{
 char szBuffer[64],szText[64];
 ProgramData ProDta;

 GetWindowText(GetDlgItem(Wea->hWnd,IDC_EDIT_LENGTH),szBuffer,16),    ProDta.dblLength=atof(szBuffer);
 GetWindowText(GetDlgItem(Wea->hWnd,IDC_EDIT_WIDTH),szBuffer,16),     ProDta.dblWidth=atof(szBuffer);
 GetWindowText(GetDlgItem(Wea->hWnd,IDC_EDIT_HEIGHT),szBuffer,16),    ProDta.dblHeight=atof(szBuffer);
 ProDta.dblVolume=ProDta.dblLength*ProDta.dblWidth*ProDta.dblHeight;
 sprintf(szBuffer,"%8.2f",ProDta.dblVolume);
 strcpy(szText,"Your ");
 GetWindowText(GetDlgItem(Wea->hWnd,IDC_COMBO_TYPE),ProDta.szBoxType,16);
 strcat(szText,ProDta.szBoxType);
 strcat(szText," Has A Volume Of ");
 strcat(szText,szBuffer);
 SetWindowText(GetDlgItem(Wea->hWnd,IDC_EDIT_VOLUME),szText);
}


void btnDisplay_OnClick(lpWndEventArgs Wea)
{
 MessageBox(Wea->hWnd, "You've Clicked The Display Button!", "Button Click Report", MB_OK);
}


long fnWndProc_OnCommand(lpWndEventArgs Wea)
{
 switch(LOWORD(Wea->wParam))
 {
    case IDC_BUTTON_CALCULATE:
         btnCalculate_OnClick(Wea);
         break;
    case IDC_BUTTON_DISPLAY:
         btnDisplay_OnClick(Wea);
         break;
 }

 return 0;
}


long fnWndProc_OnClose(lpWndEventArgs Wea)
{
 DestroyWindow(Wea->hWnd);
 PostQuitMessage(0);
 return 0;
}


void AttachEventHandlers(void)         //This procedure maps windows messages to the
{                                      //procedure which handles them.
 EventHandler[0].Code=WM_CREATE,       EventHandler[0].fnPtr=fnWndProc_OnCreate;
 EventHandler[1].Code=WM_COMMAND,      EventHandler[1].fnPtr=fnWndProc_OnCommand;
 EventHandler[2].Code=WM_CLOSE,        EventHandler[2].fnPtr=fnWndProc_OnClose;
}


long __stdcall fnWndProc(HWND hwnd, unsigned int msg, WPARAM wParam,LPARAM lParam)
{
 WndEventArgs Wea;                  //This procedure loops through the EVENTHANDER array
                                    //of structs to try to make a match with the msg parameter
 for(unsigned int i=0; i<3; i++)    //of the WndProc.  If a match is made the event handling
 {                                  //procedure is called through a function pointer -
     if(EventHandler[i].Code==msg)  //(EventHandler[i].fnPtr).  If no match is found the
     {                              //msg is passed onto DefWindowProc().
        Wea.hWnd=hwnd, Wea.lParam=lParam, Wea.wParam=wParam;
        return (*EventHandler[i].fnPtr)(&Wea);
     }
 }

 return (DefWindowProc(hwnd, msg, wParam, lParam));
}


int __stdcall WinMain(HINSTANCE hInstance, HINSTANCE hPrevIns, LPSTR lpszArgument, int iShow)
{
 char szClassName[]="Form3";
 WNDCLASSEX wc;
 MSG messages;
 HWND hWnd;

 AttachEventHandlers();
 wc.lpszClassName=szClassName;                wc.lpfnWndProc=fnWndProc;
 wc.cbSize=sizeof (WNDCLASSEX);               wc.style=CS_DBLCLKS;
 wc.hIcon=LoadIcon(NULL,IDI_APPLICATION);     wc.hInstance=hInstance;
 wc.hIconSm=LoadIcon(NULL, IDI_APPLICATION);  wc.hCursor=LoadCursor(NULL,IDC_ARROW);
 wc.hbrBackground=(HBRUSH)COLOR_BTNSHADOW;    wc.cbWndExtra=0;
 wc.lpszMenuName=NULL;                        wc.cbClsExtra=0;
 RegisterClassEx(&wc);
 hWnd=CreateWindowEx(0,szClassName,szClassName,WS_OVERLAPPEDWINDOW,200,400,410,250,HWND_DESKTOP,0,hInstance,0);
 ShowWindow(hWnd,iShow);
 while(GetMessage(&messages,NULL,0,0))
 {     //Is it not a Dialog Message?
    if(!IsDialogMessage(hWnd,&messages)) //Added this because it does special character code translations that
    {                                    //allows the use of the tab key to move focus among child window
       TranslateMessage(&messages);      //controls with the WS_TABSTOP style on the main Form.
       DispatchMessage(&messages);
    }
 }

 return messages.wParam;
}

